`timescale 1ns / 100ps

module rise_edge (
	input clk,
	input rst_n,
	input din,
	output reg dout
	);

reg d1, d2;

always @ ( posedge clk or negedge rst_n )
begin
	if ( !rst_n )
	begin
		d1 <= #2 1'b0;
		d2 <= #2 1'b0;
	end
	else 
	begin
		d1 <= #2 din;
		d2 <= #2 d1;
	end
end

always @ ( posedge clk or negedge rst_n )
begin
	if ( !rst_n )
	begin
		dout <= #2 1'b0;
	end
	else if (( d1 == 1'b1 ) && ( d2 == 1'b0 ))
	begin
		dout <= #2 1'b1;
	end
	else
	begin
		dout <= #2 1'b0;
	end
end

endmodule
